#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import pyodbc 

server = 'tcp:apa.di.unipi.it' 
database = 'Foodmart' 
username = 'lbi' 
password = 'pisa' 
cnxn = pyodbc.connect('DRIVER={ODBC Driver 17 for SQL Server};SERVER='+server+';DATABASE='+database+';UID='+username+';PWD='+ password)


customer_gender = dict()
cursor_customer = cnxn.cursor()
cursor_customer.execute("SELECT * FROM customer;") 
row = cursor_customer.fetchone() 
while row: 
    customer_gender[row.customer_id] = row.gender
    row = cursor_customer.fetchone()
cursor_customer.close()

time_ids = set()
cursor_time = cnxn.cursor()
cursor_time.execute("SELECT * FROM time_by_day;") 
row = cursor_time.fetchone() 
while row:
    if int(row.the_year) == 1998:
        time_ids.add(row.time_id)
    row = cursor_time.fetchone()
cursor_time.close()

F = 0
M = 0
store_data = dict()
cursor = cnxn.cursor()
cursor.execute("SELECT * FROM sales_fact;") 
row = cursor.fetchone() 
while row:
    if row.time_id in time_ids:
        if row.store_id not in store_data:
            store_data[row.store_id] = {"f_i" : 0, "m_i" : 0, "customers" : set()}
        if row.customer_id not in store_data[row.store_id]["customers"]:
            store_data[row.store_id]["customers"].add(row.customer_id)
            if customer_gender[row.customer_id] == "F":
                F += 1
                store_data[row.store_id]["f_i"] += 1
            else:
                M += 1
                store_data[row.store_id]["m_i"] += 1
    row = cursor.fetchone()
cursor.close()

dissimilarity_sum = 0
for store in store_data:
    females = store_data[store]["f_i"] / F
    males = store_data[store]["m_i"] / M
    dissimilarity_sum += abs(females - males)
dissimilarity_sum = dissimilarity_sum / 2

print(dissimilarity_sum)
